// gc::bit::copy::forward
//   coded by zoro (悵)
// 1997-11-02 begin
//      11-11 write off
//      11-12 checked
// 1999-02-01 begin for ai15, changed, checked
// 2007-06-15 to .cc using mactocc
//      06-25 checked on litle-endian
//      07-03 big-endian,checked

#include <stdio.h>
#include "../gc.h"
#include "bit.h"

short gcBitCopy( gcBit* dst, gcBit* src, gcRgn* rgn
, short p_dstx, short p_dsty, short p_srcx, short p_srcy)
{
#include "../tlcs900.h"
  word widthsrc;
  word widthdst;

  xwa= (dword)dst;
//<assert object>
  xbc= (dword)src;
//<assert object>
  xde= (dword)rgn;
//<assert object>
  if(m_word(xde+8)!=0) goto bccopyerr;
  widthsrc= m_word(xbc+2);
  xbc+= 4;
  if(m_word(xbc-4)==0) goto bcincsrc;
  xbc= m_dword(xbc);
bcincsrc:
  xiz= xwa;
  widthdst= m_word(xiz+2);
  xiz+= 4;
  if(m_word(xiz-4)==0) goto bcincdst;
  xiz= m_dword(xiz);
bcincdst:
  return gcBit_copyin(xiz, widthdst, xbc, widthsrc, xde
  , p_dstx, p_dsty, p_srcx, p_srcy);
bccopyerr:
  if(m_word(xde+8)==1) return 2;
  return -1;
};

short gcBit_copyin(dword addrdst, word widthdst, dword addrsrc, word widthsrc
, dword addrrgn, short p_dstx, short p_dsty, short p_srcx, short p_srcy)
{
#include "../tlcs900.h"
  word qwa;
  word qhl;
  word qde;
  word qbc;
  byte w, c, e;

  word xposition;
  word yheight;
  word  toppos;
  dword topsrc;
  dword topdst;
  dword nextsrc;
  dword nextdst;
  word blkcount;
  dword blksrc;
  dword blkdst;
  dword blkrgn;

  dmesg("copyin\n");
  xiz= addrdst;
  xbc= addrsrc;
  xde= addrrgn;
  _iy= p_srcx;
  _iy+= m_word(xde); //rgn.x
  _ix= p_dstx;
  _ix+= m_word(xde);
  _hl= 0x000f;
  _hl&= ix;
  _iy-= hl;
  _wa= 0;
  _wa-= iy;
  toppos= hl;
  _iy= (short)iy>>(3+15)%16+1;
  if(xiy&0x08000) xiy|= 0xffff0000; else xiy&= 0x0ffff;
  xiy+= xbc; //ptrsrc
  _bc= p_srcy;
  _bc+= m_word(xde+2);
  xbc= (short)xbc*(short)widthsrc;
  xiy+= xbc;
  _ix= (short)ix>>(3+15)%16+1;
  _ix&= 0xfffe;
  if(xix&0x08000) xix|= 0xffff0000; else xix&= 0x0ffff;
  xix+= xiz; //ptrdst
  _bc= p_dsty;
  _bc+= m_word(xde+2);
  xbc= (short)xbc*(short)widthdst;
  xix+= xbc;
  _wa&= 7;
  if((word)wa==0) goto bc8start;
bcstart:
  xiy-= 1;
  topsrc= xiy;
  topdst= xix;
  w= 0xff;
  w<<= (wa+15)%16+1;
  w= ~w;
  _bc= 0;
  _bc-= m_word(xde+12);
  yheight= bc;
  _bc= 0xffff;
  _bc+= m_word(xde+14);
  blkcount= bc;
  xde= xde+16;
  goto bcblkloopin;
bc8start:
  topsrc= xiy;
  topdst= xix;
  _bc= 0;
  _bc-= m_word(xde+12);
  yheight= bc;
  _bc= 0xffff;
  _bc+= m_word(xde+14);
  qwa= bc;
  xde= xde+16;
  goto bc8blkloopin;
// bit copy forward shifted
bcxtailword:
#ifdef __BIG_ENDIAN__
  _bc= xbc>>16;
#endif
  _bc^= m_word(xix);
  _bc&= iz; //tailmask
  m_word(xix)^= bc;
  qhl-= 1;
  if(qhl==0) goto bcyloopex;
bcyloop:
  xiy+= nextsrc;
  xix+= nextdst;
bcyloopin:
  xbc= (mem= xiy,xiy+= 4,m_dword(mem));
#ifdef __BIG_ENDIAN__
  e= (byte)xbc;
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#else
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
  e= (byte)xbc;
  _bc= xbc>>16;
#endif
  _bc^= m_word(xix);
  _bc&= qwa; //headmask
  (mem= xix,xix+= 2,m_word(mem))^= bc;
  _hl= qde; //xcount
  xbc= (mem= xiy,xiy+= 4,m_dword(mem));
#ifndef __BIG_ENDIAN__
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
#endif
  c= (byte)xbc;
  c^= e;
  e^= c;
  c&= w;
  c^= e;
  xbc= xbc&0xffffff00|c;
#ifdef __BIG_ENDIAN__
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#endif
  _hl-= 2;
  if((short)hl<=0) goto bcxloopex;
bcxloop:
  (mem= xix,xix+= 4,m_dword(mem))= xbc;
  xbc= (mem= xiy,xiy+= 4,m_dword(mem));
#ifndef __BIG_ENDIAN__
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
#endif
  c= (byte)xbc;
  c^= e;
  e^= c;
  c&= w;
  c^= e;
  xbc= xbc&0xffffff00|c;
#ifdef __BIG_ENDIAN__
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#endif
  _hl-= 2;
  if((short)hl>0) goto bcxloop;
bcxloopex:
  if((short)hl<0) goto bcxtailword;
  xbc^= m_dword(xix);
  xbc&= xiz; //tailmask
  m_dword(xix)^= xbc;
  qhl--; if(qhl!=0) goto bcyloop;
bcyloopex:
  blkcount-= 1;
  if(blkcount==0) goto bcblknext;
bcblkloop:
//̃ubN
  xiy= blksrc;
  xix= blkdst;
  xde= blkrgn;
  _hl= xposition;
// xix=dest xiy=src xde=rgn hl=prev-xe wa=bit
bcblkloopin:
  dmesg("xix=%d xiy=%d xde=%d hl=%d blk=%d\n", xix, xiy, xde, hl, blkcount);
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  xbc= 0x0000fff0;
  _bc&= hl;
  _bc= (word)bc>>(3+15)%16+1;
  xiy+= xbc;
  xix+= xbc;
  blksrc= xiy; //save
  blkdst= xix; //save
  _hl&= 0x000f;
  c= (byte)hl;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  blkrgn= xde; //save
  xposition= hl; //save
  xde= gcBit_bittable;
  if((word)hl<17) goto bconeword;
  if((word)hl>=25) goto bcmulti;
  if(c>=8) goto bconeword1;
bcmulti:
  c+= c;
  _bc= m_word(xde+(char)c);
  qwa= bc;
  _hl-= 1;
#ifdef __BIG_ENDIAN__
  xiz= 0xffff0000|m_word(gcBit_nottable+2+(hl&0x000f)*2);
#else
  c= 0xe0;
  c|= (byte)hl; //c is 0xe0, 0xe1, .... 0xff
  c+= c;
  c+= c; //     0x80, 0x84, .... 0xfc
  xiz= m_dword(xde+(char)c);
#endif
  _hl= (word)hl>>(4+15)%16+1;
  qde= hl; //xcount
  if((word)hl & 1) _hl++;
  _hl+= hl;
  _bc= widthsrc;
  _bc-= hl;
  _bc-= 4;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff; //nextsrc may minus
  nextsrc= xbc;
  _bc= widthdst;
  _bc-= hl;
  _bc+= 2;
  if(xbc&0x08000) xbc|= 0xffff0000; else xbc&= 0x0ffff;
  nextdst= xbc;
  _bc= yheight;
  qhl= bc; //yheight
  dmesg("%d+%d < %d+%d %04x(%d)%08x x%d\n", xix, nextdst, xiy, nextsrc, qwa, qde, xiz, qhl);
  goto bcyloopin;
bconeword1:
  xde= xde-16; //somehow tricky
  xix+= 1;
  xiy+= 1;
bconeword:
  c+= c;
  _iz= m_word(xde+(char)c);
  _hl+= hl;
  _iz^= m_word(xde+(char)hl);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _bc= yheight;
  qwa= bc;
  dmesg("%d+%d < %d+%d %04x x%d\n", xix, xde, xiy, xhl, iz, qwa);
bconeyloop:
  xbc= m_dword(xiy);
#ifdef __BIG_ENDIAN__
  xbc= xbc>>((wa+15)%16+1)|xbc<<(31-(wa+15)%16);
#else
  xbc= xbc<<((wa+15)%16+1)|xbc>>(31-(wa+15)%16);
  _bc= xbc>>16;
#endif
  _bc^= m_word(xix);
  _bc&= iz; //masksrc
  m_word(xix)^= bc;
  xiy+= xhl;
  xix+= xde;
  qwa--; if(qwa!=0) goto bconeyloop;
  blkcount-= 1;
  if(blkcount!=0) goto bcblkloop;
bcblknext:
//̃XCX
  xde= blkrgn;
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  if((word)bc==0) goto bcepilogue;
//̍s
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  if((word)hl!=0) goto bcblkexist;
  yheight+= bc; //XCXcOsɒǉ
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
bcblkexist:
  mem= yheight; yheight= bc; _bc= mem;
  _iy= widthsrc;
  xiy= (short)xiy*(short)bc;
  xiy+= topsrc;
  topsrc= xiy;
  _ix= widthdst;
  xix= (short)xix*(short)bc;
  xix+= topdst;
  topdst= xix;
  blkcount= hl;
  _hl= toppos;
  goto bcblkloopin;
// bit copy forward aligned
bc8multi:
  xde= gcBit_bit8table;
  c+= c;
  _wa= m_word(xde+(char)c);
  _hl-= 1;
  c= 0xf0;
  c|= (byte)hl;
  c+= c;
  _bc= m_word(xde+(char)c);
  qbc= bc;
  _hl= (word)hl>>(3+15)%16+1;
  _hl&= 0xfffe;
  _iz= widthsrc;
  _iz-= hl;
  if(xiz&0x08000) xiz|= 0xffff0000; else xiz&= 0x0ffff;
  _de= widthdst;
  _de-= hl;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _hl= (word)hl>>(1+15)%16+1;
  _hl-= 1;
  _bc= yheight;
  qhl= bc;
  dmesg("%d+%d < %d+%d %04x(%d)%04x x%d\n", xix, xde, xiy, xiz, wa, hl, qbc, qhl);
bc8yloop:
  _bc= (mem= xiy,xiy+= 2,m_word(mem));
  _bc^= m_word(xix);
  _bc&= wa; //headmask
  (mem= xix,xix+= 2,m_word(mem))^= bc;
  _bc= hl; //xcount
  do { m_word(xix)= m_word(xiy);
       xix+= 2; xiy+= 2; } while(--_bc, (word)bc);
  _bc= m_word(xiy);
  _bc^= m_word(xix);
  _bc&= qbc; //tailmask
  m_word(xix)^= bc;
  xiy+= xiz;
  xix+= xde;
  qhl--; if(qhl!=0) goto bc8yloop;
  qwa-= 1;
  if(qwa==0) goto bc8blknext;
bc8blkloop:
  xiy= blksrc;
  xix= blkdst;
  xde= blkrgn;
  _hl= xposition;
// xix=dest xiy=src xde=rgn hl=prev-xe
bc8blkloopin:
  dmesg("xix=%d xiy=%d xde=%d hl=%d blk=%d\n", xix, xiy, xde, hl, qwa);
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  xbc= 0x0000fff0;
  _bc&= hl;
  _bc= (word)bc>>(3+15)%16+1;
  xiy+= xbc;
  xix+= xbc;
  blksrc= xiy; //save
  blkdst= xix; //save
  _hl&= 0x000f;
  c= (byte)hl;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  blkrgn= xde; //save
  xposition= hl; //save
  if((word)hl>=41) goto bc8multi;
  if((word)hl<33) goto bc8blkword;
  if(c<8) goto bc8multi;
  c-= 8;
  _hl-= 8;
  xiy+= 1;
  xix+= 1;
bc8twoword:
  xde= gcBit_bit8tabletwo;
  _hl+= hl;
  _hl+= hl;
  xiz= m_dword(xde+(short)hl);
  c+= c;
  c+= c;
  xiz^= m_dword(xde+(char)c);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _wa= yheight;
  dmesg("%d+%d < %d+%d %08x x%d\n", xix, xde, xiy, xhl, xiz, wa);
bc8twoyloop:
  xbc= m_dword(xiy);
  xbc^= m_dword(xix);
  xbc&= xiz; //mask
  m_dword(xix)^= xbc;
  xiy+= xhl;
  xix+= xde;
  _wa--; if((word)wa!=0) goto bc8twoyloop;
  qwa-= 1; //*** out of range relative
  if(qwa!=0) goto bc8blkloop;
  goto bc8blknext;
bc8blkword:
  if((word)hl<17) goto bc8oneword;
  if((word)hl>=25) goto bc8twoword;
  if(c<8) goto bc8twoword;
  c-= 8;
  _hl-= 8;
  xiy+= 1;
  xix+= 1;
bc8oneword:
  xde= gcBit_bittable;
  _hl+= hl;
  _iz= m_word(xde+(char)hl);
  c+= c;
  _iz^= m_word(xde+(char)c);
  _hl= widthsrc;
  if(xhl&0x08000) xhl|= 0xffff0000; else xhl&= 0x0ffff;
  _de= widthdst;
  if(xde&0x08000) xde|= 0xffff0000; else xde&= 0x0ffff;
  _wa= yheight;
  dmesg("%d+%d < %d+%d %04x x%d\n", xix, xde, xiy, xhl, iz, wa);
bc8oneyloop:
  _bc= m_word(xiy);
  _bc^= m_word(xix);
  _bc&= iz; //mask
  m_word(xix)^= bc;
  xiy+= xhl;
  xix+= xde;
  _wa--; if((word)wa!=0) goto bc8oneyloop;
  qwa-= 1; //*** out of range relative
  if(qwa!=0) goto bc8blkloop;
bc8blknext:
//̃XCX
  xde= blkrgn;
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  if((word)bc==0) goto bcepilogue;
//̍s
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
  if((word)hl!=0) goto bc8blkexist;
  yheight+= bc; //XCXcOsɒǉ
  _bc= 0;
  _bc-= (mem= xde,xde+= 2,m_word(mem));
  _hl= 0xffff;
  _hl+= (mem= xde,xde+= 2,m_word(mem));
bc8blkexist:
  mem= yheight; yheight= bc; _bc= mem;
  _iy= widthsrc;
  xiy= (short)xiy*(short)bc;
  xiy+= topsrc;
  topsrc= xiy;
  _ix= widthdst;
  xix= (short)xix*(short)bc;
  xix+= topdst;
  topdst= xix;
  qwa= hl;
  _hl= toppos;
  goto bc8blkloopin;
bcepilogue:
  _hl= 1;
  return(short)hl;
};
