#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../gc.h"

void
print(short *kp)
{
  int i, j;
  printf("(%d %d)+(%d %d) %3d", kp[0], kp[1], kp[2], kp[3], kp[4]);
  if(kp[4]&1) { printf("\n"); return; };
  printf(" (%d)\n", kp[5]);
  i= 6;
  for(;;) {
    printf("%3d (%d):", kp[i], kp[i+1]);
    for(j= 1; j<kp[i+1]; j++) printf(" %3d <%3d>",  kp[i+j*2], kp[i+j*2+1]);
    printf("\n");
    if(kp[i]>=0) break;
    i+= j*2;
  };
};


main()
{
  gcBit* bit= gcBitAlloc(512, 256*3);
  printf("%d\n", bit);
  for(int i= 0; i<1000; i++) {
    //from pattern
    for(int y= 0; y<256; y++) {
      for(int x= 0; x<64; x++) {
        *(byte*)((dword)bit+4+y*64+x)= 0x00; //white
      };
    };
    //to pattern
    for(int y= 256; y<256*3; y++) {
      for(int x= 0; x<64; x++) {
        *(byte*)((dword)bit+4+y*64+x)= x+y; //random pattern
      };
    };
    //make random region
    gcRgn *sa= gcRgnRect(0, 0, 0, 0, 0);
    for(int j= 0; j<10; j++) {
      int x0, y0, x1, y1;
      do {
        x0= ((rand()/10)%400);
        y0= ((rand()/10)%200);
        x1= ((rand()/10)%400);
        y1= ((rand()/10)%200);
        if(x0>x1) { int t= x0; x0= x1; x1= t; };
        if(y0>y1) { int t= y0; y0= y1; y1= t; };
      } while((x1-x0)*(y1-y0)>=10000);
      gcRgn* ra= gcRgnRect(x0, y0, x1-x0, y1-y0, 0);
      gcRgn* nsa= gcRgnOr(sa, ra, 0, 0, 0, 0);
      gcRgnFree(sa); gcRgnFree(ra);
      sa= nsa;
    };
    printf("***************REGION MADE\n");
    int x0= ((rand()/10)%100);
    int y0= ((rand()/10)%50);
    int x1= ((rand()/10)%100);
    int y1= ((rand()/10)%50);
    gcBitCopy(bit, bit, sa, x1, y1+256, x0, y0);
    gcBitClear(bit, sa, x1, y1+512);

    if(memcmp((void*)((dword)bit+4+256*64),(void*)((dword)bit+4+512*64)
    ,256*64)!=0 || i==999) {
      printf("****%d (%d,%d)-(%d,%d)\n", i, x0, y0, x1, y1);
      print((short*)sa);
#ifdef __BIG_ENDIAN__
      int const rev= 7;
#else
      int const rev= 0;
#endif
      FILE *fp= fopen("bitmap.raw", "w");
      for(int y= 0; y<256*3*64; y++) {
        byte c= *(byte*)((dword)bit+4+y);
        char buf[8];
        for(int x= 0; x<8; x++) buf[x]= (char)((int)((c>>(x^rev))&1)-1);
        fwrite(buf, 1, 8, fp);
      };
      fclose(fp);
      exit(1);
    };
    printf("********************match %d\n", i);
    gcRgnFree(sa);
  };
};
