#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../gc.h"

void
print(short *kp)
{
  int i, j;
  printf("(%d %d)+(%d %d) %3d", kp[0], kp[1], kp[2], kp[3], kp[4]);
  if(kp[4]&1) { printf("\n"); return; };
  printf(" (%d)\n", kp[5]);
  i= 6;
  for(;;) {
    printf("%3d (%d):", kp[i], kp[i+1]);
    for(j= 1; j<kp[i+1]; j++) printf(" %3d <%3d>",  kp[i+j*2], kp[i+j*2+1]);
    printf("\n");
    if(kp[i]>=0) break;
    i+= j*2;
  };
};


main()
{
  gcBit* bit= gcBitAlloc(512, 256);
  printf("%d\n", bit);
  int offset= 255;
  for(int i= 0; i<1000; i++) {
    dword basepat= rand();
    dword fillpat= rand();
    dword andpat= rand();
    dword orpat= rand();
    //pattern
    for(int y= 0; y<256; y++) {
      for(int x= 0; x<64; x++) {
        *(byte*)((dword)bit+4+y*64+x)= (byte)(basepat>>(((offset-y)%4)*8));
      };
    };
    //make random region
    gcRgn *sa= gcRgnRect(0, 0, 0, 0, 0);
    for(int j= 0; j<10; j++) {
      int x0, y0, x1, y1;
      do {
        x0= ((rand()/10)%400);
        y0= ((rand()/10)%200);
        x1= ((rand()/10)%400);
        y1= ((rand()/10)%200);
        if(x0>x1) { int t= x0; x0= x1; x1= t; };
        if(y0>y1) { int t= y0; y0= y1; y1= t; };
      } while((x1-x0)*(y1-y0)>=10000);
      gcRgn* ra= gcRgnRect(x0, y0, x1-x0, y1-y0, 0);
      gcRgn* nsa= gcRgnOr(sa, ra, 0, 0, 0, 0);
      gcRgnFree(sa); gcRgnFree(ra);
      sa= nsa;
    };
    printf("***************REGION MADE\n");
    int x0= ((rand()/10)%100);
    int y0= ((rand()/10)%50);
    gcBitFillPat(bit, fillpat, sa, x0, y0);
    gcBitAndPat(bit, andpat, sa, x0, y0);
    gcBitOrPat(bit, orpat, sa, x0, y0);
    gcBitXorPat(bit, (fillpat&andpat|orpat)^basepat, sa, x0, y0);

    int err= 0;
    //pattern
    for(int y= 0; y<256; y++) {
      for(int x= 0; x<64; x++) {
        if(*(byte*)((dword)bit+4+y*64+x)!=(byte)(basepat>>(((offset-y)%4)*8))) err++;
      };
    };

    if(err || i==999) {
      printf("(%d,%d)\n", x0, y0);
      print((short*)sa);
      FILE *fp= fopen("bitmap.raw", "w");
#ifdef __BIG_ENDIAN__
      int const rev= 7;
#else
      int const rev= 0;
#endif
      for(int y= 0; y<256*64; y++) {
        byte c= *(byte*)((dword)bit+4+y);
        char buf[8];
        for(int x= 0; x<8; x++) buf[x]= (char)((int)((c>>(x^rev))&1)-1);
        fwrite(buf, 1, 8, fp);
      };
      fclose(fp);
      exit(1);
    };
    fprintf(stderr, "********************match %d\n", i);
    gcRgnFree(sa);
  };
};
