// gc::rgn c-interface
//   coded by zoro (悵)
// 1997-11-23 write off
// 2007-06-19 for 105gc

#include "../gc.h"
#include "rgn.h"

static gcRgn*
gcRgn_empty(short flag)
{
  gcRgn_d* td= 0;
  long sz= 10;
  short rt;
  rt= gcObjAlloc((gcObj**)&td, &sz, 0);
  if(rt<0) return(0);
  td->x= 0; td->y= 0; td->w= 0; td->h= 0; td->f= flag;
  return(gcRgn*)td;
};

gcRgn*
gcRgnAnd(gcRgn* a, gcRgn* b, short ax, short ay, short bx, short by)
{
  extern dword debug;
  gcRgn_d* td, *ad, *bd;
  short rt;
  long sz;
  ad= (gcRgn_d*)a; bd= (gcRgn_d*)b;
  ax+= ad->x; ay+= ad->y;
  bx+= bd->x; by+= bd->y;
  if(ad->f==1||bd->f==1) { //nothing
    return gcRgn_empty(1);
  } else if(ad->f==3) { //copy of b
    if(bd->f==3) return gcRgn_empty(3);
    sz= gcRgnSize(bd);
    rt= gcObjAlloc((gcObj**)&td, &sz, 0);
    if(rt<0) return(0);
    gcHeapMemMove(td, bd, sz);
    td->x= bx; td->y= by;
    return(td);
  } else if(bd->f==3) { //copy of a
    sz= gcRgnSize(ad);
    rt= gcObjAlloc((gcObj**)&td, &sz, 0);
    if(rt<0) return(0);
    gcHeapMemMove(td, ad, sz);
    td->x= ax; td->y= ay;
    return(td);
  };
  sz= 36;
  rt= gcObjAlloc((gcObj**)&td, &sz, gcHeap_ALL);
  if(rt<0) return(0);
  ////R[hbug: adbd͈ړ
  if(ad->f==0) {
    if(bd->f==0) {
      rt= gcRgnAndCore((gcRgn**)&td, sz, ad, bd, ax, ay, bx, by);
    } else {
      rt= gcRgnDiffCore((gcRgn**)&td, sz, ad, bd, ax, ay, bx, by);
    };
  } else {
    if(bd->f==0) {
      rt= gcRgnDiffCore((gcRgn**)&td, sz, bd, ad, bx, by, ax, ay);
    } else {
      rt= gcRgnOrCore((gcRgn**)&td, sz, ad, bd, ax, ay, bx, by);
      td->f|= 2;
    };
  };
  if(rt<0) { gcRgnFree(td); return(0); };
  return(td);
};

gcRgn*
gcRgnOr(gcRgn* a, gcRgn* b, short ax, short ay, short bx, short by)
{
  extern dword debug;
  gcRgn_d* td, *ad, *bd;
  short rt;
  long sz;
  ad= (gcRgn_d*)a; bd= (gcRgn_d*)b;
  ax+= ad->x; ay+= ad->y;
  bx+= bd->x; by+= bd->y;
  if(ad->f==3||bd->f==3) { //full
    return gcRgn_empty(3);
  } else if(ad->f==1) { //copy of b
    if(bd->f==1) return gcRgn_empty(1);
    sz= gcRgnSize(bd);
    rt= gcObjAlloc((gcObj**)&td, &sz, 0);
    if(rt<0) return(0);
    gcHeapMemMove(td, bd, sz); //may b->d!=bd
    td->x= bx; td->y= by;
    return(td);
  } else if(bd->f==1) { //copy of a
    sz= gcRgnSize(ad);
    rt= gcObjAlloc((gcObj**)&td, &sz, 0);
    if(rt<0) return(0);
    gcHeapMemMove(td, ad, sz); //may a->d!=ad
    td->x= ax; td->y= ay;
    return(td);
  };
  sz= 36;
  rt= gcObjAlloc((gcObj**)&td, &sz, gcHeap_ALL);
  if(rt<0) return(0);
  if(ad->f==0) {
    if(bd->f==0) {
      rt= gcRgnOrCore((gcObj**)&td, sz, ad, bd, ax, ay, bx, by);
    } else {
      rt= gcRgnDiffCore((gcObj**)&td, sz, bd, ad, bx, by, ax, ay);
      td->f= 2;
    };
  } else {
    if(bd->f==0) {
      rt= gcRgnDiffCore((gcObj**)&td, sz, ad, bd, ax, ay, bx, by);
      td->f|= 2;
    } else {
      rt= gcRgnAndCore((gcObj**)&td, sz, ad, bd, ax, ay, bx, by);
      td->f|= 2;
    };
  };
  if(rt<0) { gcRgnFree(td); return(0); };
  return(td);
};

gcRgn*
gcRgnDiff(gcRgn* a, gcRgn* b, short ax, short ay, short bx, short by)
{
  extern dword debug;
  gcRgn_d* td, *ad, *bd;
  short rt;
  long sz;
  ad= (gcRgn_d*)a; bd= (gcRgn_d*)b;
  ax+= ad->x; ay+= ad->y;
  bx+= bd->x; by+= bd->y;
  if(ad->f==1||bd->f==3) { //full
    return gcRgn_empty(1);
  } else if(ad->f==3) { //not of b
    if(bd->f==1) return gcRgn_empty(3);
    sz= gcRgnSize(bd);
    rt= gcObjAlloc((gcObj**)&td, &sz, 0);
    if(rt<0) return(0);
    gcHeapMemMove(td, bd, sz); //may b->d!=bd
    td->x= bx; td->y= by; td->f^= 2;
    return(td);
  } else if(bd->f==1) { //copy of a
    sz= gcRgnSize(ad);
    rt= gcObjAlloc((gcObj**)&td, &sz, 0);
    if(rt<0) return(0);
    gcHeapMemMove(td, ad, sz); //may a->d!=ad
    td->x= ax; td->y= ay;
    return(td);
  };
  sz= 36;
  rt= gcObjAlloc((gcObj**)&td, &sz, gcHeap_ALL);
  if(rt<0) return(0);
  if(ad->f==0) {
    if(bd->f==0) {
      rt= gcRgnDiffCore((gcObj**)&td, sz, ad, bd, ax, ay, bx, by);
    } else {
      rt= gcRgnAndCore((gcObj**)&td, sz, ad, bd, ax, ay, bx, by);
    };
  } else {
    if(bd->f==0) {
      rt= gcRgnOrCore((gcObj**)&td, sz, ad, bd, ax, ay, bx, by);
      td->f|= 2;
    } else {
      rt= gcRgnDiffCore((gcObj**)&td, sz, bd, ad, bx, by, ax, ay);
    };
  };
  if(rt<0) { gcRgnFree(td); return(0); };
  return(td);
};

gcRgn* gcRgnRect(short x, short y, short w, short h, short inv)
{
  short* td;
  long sz;
  short rt;
  if(w<=0||h<=0) {
    if(inv==0) return(gcRgn_empty(1));
    return(gcRgn_empty(3));
  };
  sz= 24;
  rt= gcObjAlloc((gcObj**)&td, &sz, 0);
  if(rt<0) return(0);
  td[0]= x; td[1]= y; td[2]= w; td[3]= h;
  td[4]= 0; td[5]= 1;
  td[6]= -h; td[7]= 2; td[8]= 0; td[9]= w;
  td[10]= 0; td[11]= 1;
  if(inv) td[4]= 2;
  return(td);
};

void
gcRgnMove(gcRgn* t, short x, short y, short inv)
{
  gcRgn_d* td;
  td= (gcRgn_d*)t;
  if(inv) td->f^= 2;
  if((td->f&1)==0) td->x+= x, td->y+= y;
};

gcRgn*
gcRgnDup(gcRgn* a, short x, short y, short inv)
{
  short rt;
  gcRgn_d* td;
  long sz;
  sz= gcRgnSize(a);
  rt= gcObjAlloc((gcObj**)&td, &sz, 0);
  if(rt<0) return(0);
  gcHeapMemMove(td, a, sz); //may a->d!=ad
  if(inv) td->f^= 2;
  if((td->f&1)==0) td->x+= x, td->y+= y;
  return(td);
};
