#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../gc.h"
#include "rgn.h"

#if 0
short gcObjAlloc(gcObj** ptr, long *sz, short mode)
{
  void *a;
  a= malloc(*sz);
  printf("Alloc %x %d\n", a, *sz);
  if(a==0) return -1;
  *ptr= a;  
  return 0;
};

short gcObjRealloc(gcObj** ptr, long *sz, short mode)
{
  void *a;
  a= realloc(*ptr, *sz);
  printf("Realloc %x %d (%x)\n", a, *sz, *ptr);
  if(a==0) return -1;
  *ptr= a;
  return 0;
};

void gcObjFree(gcObj* obj)
{
  printf("Free %x\n", obj);
  free(obj);
};

void gcHeapMemMove(void* to, void* from, long len)
{
  memcpy(to, from, len);
};
#endif


void
print(short *kp)
{
  int i, j;
  printf("(%d %d)+(%d %d) %3d", kp[0], kp[1], kp[2], kp[3], kp[4]);
  if(kp[4]&1) { printf("\n"); return; };
  printf(" (%d)\n", kp[5]);
  i= 6;
  for(;;) {
    printf("%3d (%d):", kp[i], kp[i+1]);
    for(j= 1; j<kp[i+1]; j++) printf(" %3d <%3d>",  kp[i+j*2], kp[i+j*2+1]);
    printf("\n");
    if(kp[i]>=0) break;
    i+= j*2;
  };
};

main()
{
  gcRgn* sa= gcRgnRect(0, 0, 0, 0, 0);
  gcRgn* sb= gcRgnRect(0, 0, 0, 0, 0); //empty
  for(int i= 0; i<1000; i++) {
    //make random rect
    int x0= ((rand()/10)%100)-50;
    int y0= ((rand()/10)%100)-50;
    int x1= ((rand()/10)%100)-50;
    int y1= ((rand()/10)%100)-50;
    if(x0>x1) { int t= x0; x0= x1; x1= t; };
    if(y0>y1) { int t= y0; y0= y1; y1= t; };
    gcRgn* ra= gcRgnRect(x0, y0, x1-x0, y1-y0, 0);
    gcRgn* nsa;
    if((rand()/9)%3==0) {
      printf("aOr\n");
      nsa= gcRgnOr(sa, ra, 0, 0, 0, 0);
    } else {
      printf("aDiff\n");
      nsa= gcRgnDiff(sa, ra, 0, 0, 0, 0);
    };
    gcObjFree(sa); gcObjFree(ra);
    sa= nsa;
    x0= ((rand()/10)%100)-50;
    y0= ((rand()/10)%100)-50;
    x1= ((rand()/10)%100)-50;
    y1= ((rand()/10)%100)-50;
    if(x0>x1) { int t= x0; x0= x1; x1= t; };
    if(y0>y1) { int t= y0; y0= y1; y1= t; };
    gcRgn* rb= gcRgnRect(x0, y0, x1-x0, y1-y0, 0);
    gcRgn* nsb;
    if((rand()/9)%3==0) {
      printf("bOr\n");
      nsb= gcRgnOr(sb, rb, 0, 0, 0, 0);
    } else {
      printf("bDiff\n");
      nsb= gcRgnDiff(sb, rb, 0, 0, 0, 0);
    };
    gcObjFree(sb); gcObjFree(rb);
    sb= nsb;   
    //check
    gcRgn* a1b0= gcRgnDiff(sa, sb, 0, 0, 0, 0);
    printf("a1b0\n");
    gcRgn* a0b1= gcRgnDiff(sb, sa, 0, 0, 0, 0);
    printf("a0b1\n");
    gcRgn* a1b1= gcRgnAnd(sa, sb, 0, 0, 0, 0);
    printf("a1b1\n");
    gcRgn* abor= gcRgnOr(sa, sb, 0, 0, 0, 0);
    printf("abor\n");
    gcRgn* abxor= gcRgnOr(a1b0, a0b1, 0, 0, 0, 0);
    printf("abxor\n");
    gcRgn* abeor= gcRgnDiff(abor, a1b1, 0, 0, 0, 0);
    printf("abeor\n");
    printf("abor=%x\n", abor);
    int szxor= gcRgnSize(abxor);
    int szeor= gcRgnSize(abeor);
    if(szxor!=szeor) printf("size error %d %d\n", szxor, szeor), exit(1);
    if(memcmp(abxor, abeor, szxor)!=0) printf("error\n"), exit(1);
    printf("%d*****************************pass %d\n", szxor, i);
    printf("abor=%x\n", abor);
    gcObjFree(a1b0);
    gcObjFree(a0b1);
    gcObjFree(a1b1);
    gcObjFree(abor);
    gcObjFree(abxor);
    gcObjFree(abeor);
  };
};




void main2()
{
  gcRgn* t;
  short i;
  short sa[]= {
    108, 100, 25, 25,
    0, 1,
    -10, 3, 0, 10, 10, 5,
    -10, 1,
    -5, 3,  5, 5, 5, 5,
    0, 1,
  };
  short sb[]= {
    100, 100, 25, 25,
    0, 1,
    -10, 3, 0, 10, 10, 5,
    -10, 1,
    -5, 3,  5, 5, 5, 5,
    0, 1,
  };

  printf("*AND*\n");
  t= gcRgnAnd((gcRgn*)&sa[0], (gcRgn*)&sb[0], 0, 0, 0, 0);
  if(t) {
    print((short*)t);
  } else printf("error\n");

  printf("*DIFF*\n");
  t= gcRgnDiff((gcRgn*)&sa[0], (gcRgn*)&sb[0], 0, 0, 0, 0);
  if(t) {
    print((short*)t);
  } else printf("error\n");
  printf("*OR*\n");
  t= gcRgnOr((gcRgn*)&sa[0], (gcRgn*)&sb[0], 0, 0, 0, 0);
  if(t) {
    print((short*)t);
  } else printf("error\n");
};
